import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;

public class Main {
	private JFrame janela;
	private JLabel labelNome;
	private JLabel labelIdade;
	private JLabel labelBrasileiro;
	private JTextField textNome;
	private JTextField textIdade;
	private JCheckBox checkBrasileiro;
	private JPanel panelCampos;
	private JButton gravar;
	private JButton limpar;
	private JButton apagar;
	private JButton sair;
	private JPanel panelButtons;
	private List<Pessoa> pessoas;
	private PessoaTableModel ptm;
	private JTable tabela;

	public Main() {
		janela = new JFrame("Teste Tabela");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setLayout(new BorderLayout());

		labelNome = new JLabel("Nome");
		labelIdade = new JLabel("Idade");
		labelBrasileiro = new JLabel("Brasileiro");

		textNome = new JTextField(20);
		textIdade = new JTextField(20);
		checkBrasileiro = new JCheckBox();

		panelCampos = new JPanel(new GridLayout(3, 2));
		panelCampos.add(labelNome);
		panelCampos.add(textNome);
		panelCampos.add(labelIdade);
		panelCampos.add(textIdade);
		panelCampos.add(labelBrasileiro);
		panelCampos.add(checkBrasileiro);

		gravar = new JButton("Gravar");
		gravar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (textNome.getText().compareTo("") == 0) {
					JOptionPane.showMessageDialog(gravar, "Campo nome vazio",
							"Alerta", 0);
				} else {
					String nome = textNome.getText();
					int idade = 0;
					try {
						idade = Integer.valueOf(textIdade.getText());
						Boolean brasileiro = checkBrasileiro.isSelected();
						int linha = tabela.getSelectedRow();
						if (linha < 0) {
							pessoas.add(new Pessoa(nome, idade, brasileiro));
							ptm.setPessoas(pessoas);
						} else {
							Pessoa p = pessoas.get(linha);
							p.setNome(nome);
							p.setIdade(idade);
							p.setBrasileiro(brasileiro);
							ptm.setPessoas(pessoas);
						}
					} catch (Exception e1) {
						JOptionPane.showMessageDialog(gravar,
								"O campo idade precisa ser um inteiro", "Erro",
								0);
					}
				}
			}
		});
		limpar = new JButton("Limpar");
		limpar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textNome.setText("");
				textIdade.setText("");
				checkBrasileiro.setSelected(false);
				tabela.getSelectionModel().clearSelection();
			}
		});
		apagar = new JButton("Apagar");
		apagar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int linha = tabela.getSelectedRow();
				if (linha < 0) {
					JOptionPane.showMessageDialog(apagar,
							"Favor selecionar a linha a excluir", "Alerta", 0);
				} else {
					textNome.setText("");
					textIdade.setText("");
					checkBrasileiro.setSelected(false);
					pessoas.remove(linha);
					ptm.setPessoas(pessoas);
				}
			}
		});
		sair = new JButton("Sair");
		sair.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});
		panelButtons = new JPanel();
		panelButtons.add(gravar);
		panelButtons.add(limpar);
		panelButtons.add(apagar);
		panelButtons.add(sair);

		pessoas = new ArrayList<Pessoa>();
		pessoas.add(new Pessoa("Carlos", 25, true));
		pessoas.add(new Pessoa("Juliana", 18, true));
		pessoas.add(new Pessoa("John", 40, false));

		ptm = new PessoaTableModel();
		ptm.setPessoas(pessoas);

		tabela = new JTable();
		tabela.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() >= 0) {
					int linha = tabela.getSelectedRow();
					if (linha >= 0) {
						Pessoa p = pessoas.get(linha);
						textNome.setText(p.getNome());
						textIdade.setText(Integer.toString(p.getIdade()));
						checkBrasileiro.setSelected(p.isBrasileiro());
					}
				}
			}
		});
		tabela.setModel(ptm);
		janela.add(panelCampos, BorderLayout.NORTH);
		janela.add(panelButtons);
		janela.add(new JScrollPane(tabela), BorderLayout.SOUTH);
		janela.pack();
		janela.setVisible(true);
	}

	public static void main(String[] args) {
		new Main();
	}
}
